#include<bits/stdc++.h>
using namespace std;
int main()
{
    ifstream fi("sortmt.inp");
    ofstream fo("sortmt.out");
    int m,n;
    fi>>m>>n;
    int a[m*n+1];
    int b[m*n+1];
    int mx[m+1];
    for(int i=1;i<=m*n;i++)
    {
        fi>>a[i];
        b[i]=a[i];
    }
    sort(a+1,a+m*n+1);
    fo<<a[n*m]<<' '<<a[1]<<'\n';
    for(int i=1;i<=m*(n-1);i+=n)
    {
        sort(b+i,b+i+n);
        for(int j=i;j<i+n;j++)
        {
            fo<<b[j]<<' ';
        }
        fo<<'\n';
    }
}
